#!/usr/bin/env ruby

start = Time.now
log = open('lagproxy.log', 'a')

require 'cgi'
require 'net/http'

#delay = 1.0 + rand * 2; cache_dir = 'lagcache'
delay = 0.1; cache_dir = 'lagcache'

cgi = CGI.new

esc_query_string = CGI.escape(cgi.query_string)

#unless(File.exist?(cache_dir + '/' + esc_query_string))
if(true)

	# ノーキャッシュ
	log.puts('Req: No cache - ' + cgi.query_string)

	uri = URI.parse(cgi.query_string)
	res = Net::HTTP.get_response(uri)

	Dir.mkdir(cache_dir) unless(Dir.exist?(cache_dir))
	File.open(cache_dir + '/' + esc_query_string, 'w') {|fh|
		res.each_header {|k, v|
			fh.write("%s: %s\n" % [k, v])
		}
		fh.write("\n" + res.body)
	}
else

	# キャッシュヒット
	log.puts('Req: Hit cache - ' + cgi.query_string)
end

head_body = nil; File.open(cache_dir + '/' + esc_query_string) {|fh|
	head_body = fh.read(nil)
}

wait = start.to_f + delay - Time.now.to_f
sleep(wait) if(wait > 0)

print(head_body)

__END__

